SystemOrganization addCategory: #'Glamour-Roassal-Interactive'!

GLMGlobalBrowserTemplate subclass: #GLMRoassalInteractive
	instanceVariableNames: ''
	classVariableNames: 'Repository'
	poolDictionaries: ''
	category: 'Glamour-Roassal-Interactive'!

!GLMRoassalInteractive class methodsFor: 'as yet unclassified' stamp: 'BenComan 10/2/2012 22:02'!
getShortcutButton
	"
	GLMRoassalInteractive getShortcutButton
	"
	( (PluggableButtonMorph on: GLMRoassalInteractive getState: nil action: #open) label: 'Interactive Roassal' ) openInHand.! !

!GLMRoassalInteractive methodsFor: 'as yet unclassified' stamp: 'BenComan 10/1/2012 21:16'!
addChildElementIn: model searching: rawView
	| targetElement  |
	self flag: 'This would be simplified if menu actions could receive the target graphic element directly rather than having to look it by from rawView, which is the only reason for rawView being passed around here.'.
	targetElement := rawView elementFromModel: model.
	targetElement add: ( self newElementOn: rawView ).
	targetElement applyLayout.
	rawView signalUpdate.
	
		! !

!GLMRoassalInteractive methodsFor: 'as yet unclassified' stamp: 'BenComan 10/3/2012 00:54'!
buildBrowser
	"self open"
	browser := GLMTabulator new.
	browser  title: 'Interactive Roassal'.
	browser column: [ :column | column row: #repository; row: #elementTree; row: #details ].
	browser column: [ :column | column row: #drawing ].

	browser transmit 
		to: #repository;
		andShow: 
		[ 	:composer | 
			composer list 
				title: 'Drawings Repository';
				act: 
				[ 	:presentation :model | 
					self entityReset. 
					(browser pane port: #entity) value: self entity 
				] entitled: 'Reset all sample data';
				act: 
				[	: persentation :model |
					GLMRoassalInteractive browse.
				] entitled: 'Browse GLMRoassalInteractive'
		].
	
	browser transmit 
		from: #repository;
		to: #drawing;
		andShow:
		[	:composer |
			composer roassalRaw
				title: 'Drawing';
				painting: 
				[ 	:rawView :savedRoassalDrawing | 
					rawView initializeFrom: savedRoassalDrawing value. 			
				].
		].
	
	browser transmit
		from: #repository;
		to: #elementTree;
		andShow:
		[	:composer |
			composer tree
				display: [ :repositoryAssociation | repositoryAssociation value ];
				children: [ :parent | parent elements ].
		].	
		
	browser transmit 
		from: #elementTree;
		to: #details;
		andShow:
		[ 	:composer |  
			composer text
		].
	
	browser transmit
		from: #drawing;
		to: #details;
		andShow:
		[ 	:composer |  
			composer text
		].
! !

!GLMRoassalInteractive methodsFor: 'as yet unclassified' stamp: 'BenComan 10/2/2012 21:13'!
elementMenuOn: rawView   
	self flag: '1. This would be simpler if menu actions could receive the graphic element rather than the model.  We can easily get the model from the graphic element, but in reverse we have to search the whole drawing down from rawView, and hope there are no confounding factors.'.
	
	^ ROMenuActivable new
		item: 'Add child element' action:
		[	:model |
			self addChildElementIn: model searching: rawView
		];
	
		item: 'Re-apply current layout'  action:
		[	:model |
			(rawView elementFromModel: model) applyLayout.	
			self flag: '2. Need to work out why this does not redraw until cursor moves within bounds of future location of elements'.
		];
	
		item: 'Apply vertical layout' action:
		[	:model |
			(rawView elementFromModel: model) layout: (ROVerticalLineLayout new gapSize: 20); applyLayout.	
			self flag: 'as 2. above'.
		];
	
		item: 'Apply horizontal layout' action:
		[	:model |
			(rawView elementFromModel: model) layout: (ROHorizontalLineLayout new gapSize: 20); applyLayout.	
			self flag: 'as 2. above'.
		];
	
		item: 'Apply grid layout' action:
		[	:model |
			(rawView elementFromModel: model) layout: (ROGridLayout new gapSize: 20); applyLayout.	
			self flag: 'as 2. above'.
		];

		item: 'Explore graphic element' action:
		[	:model |
			(rawView elementFromModel: model) explore.
		]

! !

!GLMRoassalInteractive methodsFor: 'as yet unclassified' stamp: 'BenComan 10/3/2012 00:48'!
entity
	| view rawView outer |
	Repository ifNil: 
	[ 
		Repository := OrderedCollection new .
		self flag: 'For initial debugging/development provide some sample data. See GLMGlobalBrowserTemplate>>open'.
		self fillSampleDataOn: Repository.
	].	
	^Repository  ! !

!GLMRoassalInteractive methodsFor: 'as yet unclassified' stamp: 'BenComan 10/1/2012 22:19'!
entityReset
	| view rawView outer |
	Repository := nil.
	self entity.
! !

!GLMRoassalInteractive methodsFor: 'as yet unclassified' stamp: 'BenComan 10/3/2012 01:17'!
fillSampleDataOn: repository
	"For initial debugging/development provide some sample data. See GLMGlobalBrowserTemplate>>open"

	| rawView outer |

	rawView := ROView new @ RODraggable.
	rawView add: ( outer := (self newElementOn: rawView) - ROLabel ).
	outer add: ((self newElementOn: rawView) on: ' 1. Right-click-here to add nodes and apply layouts').
	outer add: ((self newElementOn: rawView) on: ' 2. Layout bug waits until mouse moved to future element position').
	outer layout: ROVerticalLineLayout; applyLayout.
	outer add: ((self newElementOn: rawView) on: ' 3. Work around bug where new element is not transmitted 
to #details pane by flipping between drawings').
	outer add: ((self newElementOn: rawView) on: ' 4. Reset sample data from Repository menu').
	outer add: ((self newElementOn: rawView) on: ' 5. Close editor, then re-open to continue where you left off').
	outer layout: ROVerticalLineLayout; applyLayout.
	repository add: ( 'roassalSample1' -> rawView ).

	rawView := ROView new @ RODraggable.
	rawView add: ( outer := (self newElementOn: rawView) - ROLabel ).
	outer add: ((self newElementOn: rawView) on: ' saved sample').
	outer add: ((self newElementOn: rawView) on: ' close this editor then re-open editor').
	outer layout: ROVerticalLineLayout; applyLayout.
	repository add: ( 'roassalSample2' -> rawView ).
		! !

!GLMRoassalInteractive methodsFor: 'as yet unclassified' stamp: 'BenComan 10/2/2012 21:14'!
newElementOn: rawView
	| newElement |
	self flag: 'UUID only required to keep #elementFromModel search unique.  This might not be required if we could receive graphic element rather than the model.'.
	newElement := ROElementWithLayout spriteOn: (UUID new asString copyFrom: 1 to: 8). 
	newElement + (ROLabel).  
	newElement @ ROLightlyHighlightable @ (self elementMenuOn: rawView). 
	newElement layout: (ROGridLayout new gapSize: 20 ).
	^newElement 
	

! !

!GLMMorphicRenderer methodsFor: '*Glamour-Roassal-Interactive' stamp: 'BenComan 10/1/2012 10:07'!
renderRoassalRawPresentation: aPresentation
	^ GLMMorphicRoassalRawRenderer render: aPresentation from: self! !

ROElement subclass: #ROElementWithLayout
	instanceVariableNames: 'layout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Roassal-Interactive'!

!ROElementWithLayout class methodsFor: 'as yet unclassified' stamp: 'BenComan 9/30/2012 18:30'!
layout: aROLayout on: anObject
	^(self on: anObject) layout: aROLayout
	
! !

!ROElementWithLayout methodsFor: 'accessing' stamp: 'BenComan 10/1/2012 22:42'!
applyLayout
	layout on: (self elements select: [ :el | el isNotEdge ])."edges: self edges".
	self flag: 'Next line exit condition is a hack so as to not yet extend ROView with #applyLayout'.
	(parent isKindOf: ROView) ifTrue: [^self ].   
	parent applyLayout.! !

!ROElementWithLayout methodsFor: 'accessing' stamp: 'BenComan 9/30/2012 18:29'!
initialize 
	super initialize.
	layout := RONullLayout.! !

!ROElementWithLayout methodsFor: 'accessing' stamp: 'BenComan 9/30/2012 12:12'!
layout
	^ layout! !

!ROElementWithLayout methodsFor: 'accessing' stamp: 'BenComan 9/30/2012 12:12'!
layout: anObject
	layout := anObject! !

!GLMCompositePresentation methodsFor: '*Glamour-Roassal-Interactive' stamp: 'BenComan 10/1/2012 08:49'!
roassalRaw
	^ self custom: GLMRoassalRawPresentation new! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicRoassalRawRenderer
	instanceVariableNames: 'myMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Roassal-Interactive'!

!GLMMorphicRoassalRawRenderer methodsFor: 'rendering' stamp: 'BenComan 10/1/2012 10:01'!
actOnPresentationUpdate: ann
	| aView |
	aView := ROMondrianViewBuilder new.
	ann presentation renderOn: aView.
	myMorph setView: aView stack.! !

!GLMMorphicRoassalRawRenderer methodsFor: 'rendering' stamp: 'BenComan 10/1/2012 10:03'!
render: aRoassalPresentation
	| view |
	view := aRoassalPresentation view.
	aRoassalPresentation renderOn: view.
	aRoassalPresentation on: GLMPresentationUpdated send: #actOnPresentationUpdate: to: self.
	myMorph := ROMorph on: view. 
	^ myMorph ! !

!ROView methodsFor: '*Glamour-Roassal-Interactive' stamp: 'BenComan 10/1/2012 12:22'!
eventHandler
	^ eventHandler! !

!ROView methodsFor: '*Glamour-Roassal-Interactive' stamp: 'BenComan 10/1/2012 12:15'!
initializeFrom: aROView
	super initialize.
	elements := aROView elements.
	camera := aROView camera.
	eventHandler := aROView eventHandler.
	title := aROView title.
	backgroundColor := aROView backgroundColor.! !

GLMPresentation subclass: #GLMRoassalRawPresentation
	instanceVariableNames: 'painting paintingBlock rawView shouldPopulateSelection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Roassal-Interactive'!

!GLMRoassalRawPresentation methodsFor: 'accessing' stamp: 'BenComan 10/1/2012 08:45'!
bitmap 
	^ self view bitmap ! !

!GLMRoassalRawPresentation methodsFor: 'initialize-release' stamp: 'BenComan 10/1/2012 08:45'!
initialize 
	super initialize.
	shouldPopulateSelection := true! !

!GLMRoassalRawPresentation methodsFor: 'scripting' stamp: 'BenComan 10/1/2012 08:45'!
painting: anObject
	paintingBlock := anObject! !

!GLMRoassalRawPresentation methodsFor: 'accessing' stamp: 'BenComan 10/1/2012 08:45'!
paintingBlock
	^ paintingBlock! !

!GLMRoassalRawPresentation methodsFor: 'rendering' stamp: 'BenComan 10/1/2012 10:06'!
renderGlamorouslyOn: aRenderer
	self registerAnnouncements.
	^ aRenderer renderRoassalRawPresentation: self! !

!GLMRoassalRawPresentation methodsFor: 'accessing' stamp: 'BenComan 10/2/2012 21:51'!
renderOn: rawViewparam
	self flag: 'find a smarter solution that does not depend on isKindOf:'. 
	self paintingBlock glamourValue: (
		(self entity isKindOf: GLMMultiValue) 
				ifTrue: [(GLMMultiValue with: rawViewparam) , self entity , (GLMMultiValue with: self)] 
				ifFalse: [GLMMultiValue with: rawViewparam with: self entity with: self]).
	self flag: 'This should be the responsibility of the the view'.
	self shouldPopulateSelection ifTrue: [
		rawViewparam allElementsDo: [:each | 
			each on: ROMouseClick do: [:event | self selection: each model ]] ].
	self view: rawViewparam! !

!GLMRoassalRawPresentation methodsFor: 'accessing' stamp: 'BenComan 10/1/2012 08:45'!
shouldPopulateSelection
	"this flag tells the presentation whether clicking on some element inside
	the view should populate the selection port from the pane containing the presentation"
	^ shouldPopulateSelection! !

!GLMRoassalRawPresentation methodsFor: 'accessing' stamp: 'BenComan 10/1/2012 08:45'!
shouldPopulateSelection: anObject
	shouldPopulateSelection := anObject! !

!GLMRoassalRawPresentation methodsFor: 'accessing' stamp: 'BenComan 10/1/2012 09:42'!
view
	^ rawView ifNil: [rawView := ROView new]! !

!GLMRoassalRawPresentation methodsFor: 'accessing' stamp: 'BenComan 10/1/2012 09:40'!
view: anObject
	rawView := anObject! !
